/*
 * iterator.h
 *
 *  Created on: 03 . 2014 .
 *      Author: Allex
 */

#ifndef ITERATOR_H_
#define ITERATOR_H_

#include "sgCore/sgCore.h"
#include <vector>

class sgIterator{
protected:
	std::vector<IObjectsList*>	m_Lists;
	std::vector<sgCGroup*>	m_Group;
	sgCObject*				m_Next;
	IObjectsList*			m_MainList;
	bool					m_SkipGroups;
	sgCGroup*				m_CurrentItemGroup;

	void getAnyNext(){
		if (m_Next->GetType()==SG_OT_GROUP){
			m_Group.push_back(((sgCGroup*)m_Next));
			m_Lists.push_back(((sgCGroup*)m_Next)->GetChildrenList());
			m_Next = m_Lists[m_Lists.size()-1]->GetHead();
			if (m_Next!=0)
				return;

			m_Next = m_Group[m_Group.size()-1];
			m_Group.pop_back();
			m_Lists.pop_back();
		}

		bool needNext = false;
		do{
			m_Next = m_Lists[m_Lists.size()-1]->GetNext(m_Next);
			if (m_Next==0){
				if (m_Group.size()==0){
					return;
				}
				m_Next = m_Group[m_Group.size()-1];

				m_Group.pop_back();
				m_Lists.pop_back();
				needNext = true;
			}
			else
				needNext = false;
		}while(m_Next==0 || needNext);
	}

	void getNextLeaf(){
		if (!m_SkipGroups)
			return;
		while (m_Next!=0 && m_Next->GetType()==SG_OT_GROUP)
			getAnyNext();
	}
public:
	sgIterator(IObjectsList* MainList, bool skipGroups = true){
		m_MainList = MainList;
		m_SkipGroups = skipGroups;
		reset();
	}

	void reset(){
		m_CurrentItemGroup = 0;
		m_Lists.resize(0);
		m_Lists.push_back(m_MainList);
		m_Group.resize(0);
		m_Next = m_MainList->GetHead();

		m_Lists.resize(0);
		m_Lists.push_back(m_MainList);
		m_Group.resize(0);
		m_Next = m_MainList->GetHead();
		getNextLeaf();
	}

	sgCObject* getNext(){
		if (m_Next==0)
			return 0;
		sgCObject* current = m_Next;
		if (m_Group.size()==0)
			m_CurrentItemGroup=0;
		else
			m_CurrentItemGroup=m_Group[0];
		getAnyNext();
		getNextLeaf();

		return current;
	}

	sgCGroup* getMainGroup(){
		return m_CurrentItemGroup;
	}
};


#endif /* ITERATOR_H_ */
