package com.geometros.javademo;

import javax.microedition.khronos.opengles.GL10;

import android.content.Context;
import android.opengl.GLSurfaceView;
import android.opengl.GLSurfaceView.Renderer;

public class SceneRenderer implements Renderer {
	
	protected int width;
	protected int height;
	protected boolean needInit = true;
	protected Context parent;
	protected Shader shaderScene;
	protected Shader shaderFloor;
	protected Texture floorTexture;
	
	protected float xAngle = 0;
	protected float yAngle = +35;
	
	public SceneRenderer(Context context, GLSurfaceView SurfaceView){
		parent = context;
	}
	
	
	protected void reinit(){
		shaderScene = new Shader(parent, R.raw.objectvs,R.raw.objectfs);
		shaderFloor = new Shader(parent, R.raw.floorvs,R.raw.floorfs);
		floorTexture = new Texture(parent, "floor.png");
		SceneView.nativeReinitGL(shaderScene.getGLProgram(), shaderFloor.getGLProgram(), floorTexture.getGLID());
	}
	
	@Override
	public void onSurfaceCreated(GL10 gl,javax.microedition.khronos.egl.EGLConfig config) {
		if (needInit)
			return;	
		reinit();
	}
	
	
	@Override
    public void onDrawFrame(GL10 unused) {
		if (needInit){
			SceneView.nativeInit(SceneView.TempDir);
			
			reinit();
			needInit = false;
		}
		SceneView.nativeDraw(width, height, xAngle, yAngle);		
    }

	@Override
    public void onSurfaceChanged(GL10 unused, int Width, int Height) {
        width = Width;
        height = Height;
    }

	public void touch(float xShift, float yShift){
		xAngle += xShift;
		yAngle += yShift;/*
		if (yAngle<5)
			yAngle = 5;
		if (yAngle>75)
			yAngle = 75;*/
	}
	
}

