package com.geometros.javademo;

import java.io.File;

import android.content.Context;
import android.opengl.GLSurfaceView;
import android.os.Environment;
import android.view.MotionEvent;

public class SceneView extends GLSurfaceView {
		
	protected Context Parent;
	public SceneRenderer Renderer;
	
	static {
		System.loadLibrary("sgWrapper");	}
	
		public static native void nativeInit(String tempDir);
		public static native void nativeReinitGL(int shaderScene, int shaderFloor, int floorTexture);
		public static native void nativeRelease();
		public static native void nativeClear();
		public static native void nativeDraw(int width, int height, float xAngle, float yAngle);
		public static native void nativeLoadScene(int id);
		
	public static String WorkDir = Environment.getExternalStorageDirectory().toString()+"/sgDemo/";
	public static String TempDir = Environment.getExternalStorageDirectory().toString()+"/sgDemo/temp";
	
	public static void createFolders(){
        File folder = new File(WorkDir);
    	if (!folder.exists()){
    		android.util.Log.v("WORK DIR", WorkDir);
    		folder.mkdir();
    	}
    	folder = new File(TempDir);
    	if (!folder.exists())
    		folder.mkdir();
	}
		
	public SceneView(Context context){
        super(context);
        Parent = context;
        
        createFolders();
        
        tools.copyAssetFile(context, "fonts/Helvetica.shx", TempDir+"/Helvetica.shx");
        tools.copyAssetFile(context, "dino.stl", TempDir+"/dino.stl");
        tools.copyAssetFile(context, "statue.dxf", TempDir+"/statue.dxf");

        // Set the Renderer for drawing on the GLSurfaceView
        setEGLContextClientVersion(2);
        Renderer = new SceneRenderer(context,this);
        setRenderer(Renderer);
    }
	
	protected float prevX = 0;
	protected float prevY = 0;
	
	@Override
	public boolean onTouchEvent(MotionEvent event)
	{
		 float x = event.getX();
		 float y = event.getY();
		 
		 final float diffX = x-prevX;
		 final float diffY = y-prevY;
		 
		 prevX = x;
 		 prevY = y;
		 
		 
		 if (event != null){
	    	int action = event.getAction();
	    	if (action==MotionEvent.ACTION_DOWN)
	    		return true;
	        if (action==MotionEvent.ACTION_MOVE || action==MotionEvent.ACTION_UP){
	            if (Renderer != null){
                    queueEvent(new Runnable()
	                    {
	                        @Override
	                        public void run()
	                        {
	                        	Renderer.touch(diffX,diffY);
	                        }
	                    });
	 
                    return true;
                }
            }
	        
	    }	 
        return super.onTouchEvent(event);
    }
	 
	 
}
