package com.geometros.javademo;

import java.io.IOException;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.opengl.GLES20;
import android.opengl.GLUtils;

public class Texture {
	private int textureID;
	private int width;
	private int height;
	
	protected void init(Bitmap bitmap){
		int[] textureIds = new int[1];
	    GLES20.glGenTextures( 1, textureIds, 0 );

	    GLES20.glBindTexture( GLES20.GL_TEXTURE_2D, textureIds[0] );

	    GLES20.glTexParameterf( GLES20.GL_TEXTURE_2D, GLES20.GL_TEXTURE_MIN_FILTER, GLES20.GL_LINEAR );
	    GLES20.glTexParameterf( GLES20.GL_TEXTURE_2D, GLES20.GL_TEXTURE_MAG_FILTER, GLES20.GL_LINEAR );

	    GLES20.glTexParameterf( GLES20.GL_TEXTURE_2D, GLES20.GL_TEXTURE_WRAP_S, GLES20.GL_REPEAT );
	    GLES20.glTexParameterf( GLES20.GL_TEXTURE_2D, GLES20.GL_TEXTURE_WRAP_T, GLES20.GL_REPEAT );
	    GLUtils.texImage2D( GLES20.GL_TEXTURE_2D, 0, bitmap, 0 );
	    
	    width = bitmap.getWidth();
	    height = bitmap.getHeight();
	    
	    textureID = textureIds[0];
	}
	
	public Texture(Context context, String AssetFile){
		Bitmap bmp;
		try {
			bmp = BitmapFactory.decodeStream(context.getAssets().open(AssetFile));
			init(bmp);
			bmp.recycle();
		} catch (IOException e) {
			e.printStackTrace();
		}		
	}
		
	public Texture(Bitmap bitmap){
		init(bitmap);
	}
	
	public int getGLID(){
		return textureID;
	}
	
	public void release(){
		int[] textureIds = new int[1];
		textureIds[0] = textureID;
		GLES20.glDeleteTextures(1, textureIds, 0);
	}
	
	public int getWidth(){
		return width;
	}
	
	public int getHeight(){
		return height;
	}
}
