#include "Scenes.h"
#include <math.h>

#include <cstdlib>

#import "../../sgCore/sgCore.h"



void OnBnClickedKinRotSurf()
{
  sgGetScene()->Clear();

  AddFloorInScene(15.0, 14.0, -2.0, 2.0, -3.0);

    SG_POINT tmpPnt;

  SG_SPLINE* spl2 = SG_SPLINE::Create();

   tmpPnt.x = 1.0; tmpPnt.y = -3.0; tmpPnt.z = 0.0;
  spl2->AddKnot(tmpPnt,0);
  tmpPnt.x = 3.0; tmpPnt.y = -2.0; tmpPnt.z = 0.0;
  spl2->AddKnot(tmpPnt,1);
  tmpPnt.x = 2.0; tmpPnt.y = -1.0; tmpPnt.z = 0.0;
  spl2->AddKnot(tmpPnt,2);
  tmpPnt.x = 3.0; tmpPnt.y = 1.0; tmpPnt.z = 0.0;
  spl2->AddKnot(tmpPnt,3);
  tmpPnt.x = 2.0; tmpPnt.y = 4.0; tmpPnt.z = 0.0;
  spl2->AddKnot(tmpPnt,4);
  tmpPnt.x =4.0; tmpPnt.y = 5.0; tmpPnt.z = 0.0;
  spl2->AddKnot(tmpPnt,5);

  sgCSpline* spl2_obj = sgCreateSpline(*spl2);
  sgGetScene()->AttachObject(spl2_obj);
  spl2_obj->SetAttribute(SG_OA_COLOR,12);
  spl2_obj->SetAttribute(SG_OA_LINE_THICKNESS, 2);

  SG_SPLINE::Delete(spl2);

  SG_POINT p1 = {0,-2,0};
  SG_POINT p2 = {0,0,0};

   sgC3DObject* rO = (sgC3DObject*)sgKinematic::Rotation(*spl2_obj,p1,p2,250,false);

   sgGetScene()->AttachObject(rO);
  rO->SetAttribute(SG_OA_COLOR,3);

  SG_VECTOR transV1 = {-1,0,0};
  rO->InitTempMatrix()->Translate(transV1);
  rO->ApplyTempMatrix();
  rO->DestroyTempMatrix();
}

void OnBnClickedKinRotBod()
{
  sgGetScene()->Clear();

   SG_POINT tmpPnt;

  //SG_SPLINE* spl2 = SG_SPLINE::Create();

  
  SG_SPLINE* spl2 = SG_SPLINE::Create();
  int fl=0;
  for (double i=0.0;i<2.0*3.14159265;i+=0.4)
  {
    tmpPnt.x = ((double)(fl%3+2))*cos(i);
    tmpPnt.y = ((double)(fl%3+2))*sin(i);
    tmpPnt.z = 0.0;
    spl2->AddKnot(tmpPnt,fl);
    fl++;
  }
  spl2->Close();

  sgCSpline* spl2_obj = sgCreateSpline(*spl2);
  sgGetScene()->AttachObject(spl2_obj);
  spl2_obj->SetAttribute(SG_OA_COLOR,12);
  spl2_obj->SetAttribute(SG_OA_LINE_THICKNESS,2);

  SG_SPLINE::Delete(spl2);

  SG_POINT p1 = {10,10,0};
  SG_POINT p2 = {20,15,0};

    sgC3DObject* rO = (sgC3DObject*)sgKinematic::Rotation(*spl2_obj,p1,p2,290,true);

   sgGetScene()->AttachObject(rO);
  rO->SetAttribute(SG_OA_COLOR,8);

  SG_VECTOR transV1 = {-6,0,0};
  rO->InitTempMatrix()->Translate(transV1);
  rO->ApplyTempMatrix();
  rO->DestroyTempMatrix();

}

void OnBnClickedKinExtrSurf()
{
  sgGetScene()->Clear();

  
  SG_POINT tmpPnt;

  SG_SPLINE* spl2 = SG_SPLINE::Create();

  
  int fl=0;
  for (double i=0.0;i<10.0;i+=1.0)
  {
    tmpPnt.x = i;
    tmpPnt.y = (fl%2)?-i/2.0:i/2.0;
    tmpPnt.z = 0.0;
    spl2->AddKnot(tmpPnt,fl);
    fl++;
  }


  sgCSpline* spl2_obj = sgCreateSpline(*spl2);
  sgGetScene()->AttachObject(spl2_obj);
  spl2_obj->SetAttribute(SG_OA_COLOR,12);
  spl2_obj->SetAttribute(SG_OA_LINE_THICKNESS, 2);

  SG_SPLINE::Delete(spl2);

  SG_VECTOR extVec = {1,-2,3};

   sgC3DObject* exO = (sgC3DObject*)sgKinematic::Extrude((const sgC2DObject&)(*spl2_obj),NULL,0,extVec,false);

  sgGetScene()->AttachObject(exO);
  exO->SetAttribute(SG_OA_COLOR,20);

  SG_VECTOR transV1 = {8,0,0};
  exO->InitTempMatrix()->Translate(transV1);
  exO->ApplyTempMatrix();
  exO->DestroyTempMatrix();

}

void OnBnClickedKinExtrBod()
{
  sgGetScene()->Clear();

  AddFloorInScene(30.0, 25.0, -2.0, 0.0, -2.0);

  
  SG_POINT tmpPnt;

  
  SG_SPLINE* spl2 = SG_SPLINE::Create();
  int fl=0;
  for (double i=0.0;i<2.0*3.14159265;i+=0.13)
  {
    tmpPnt.x = ((double)(fl%3+2))*cos(i);
    tmpPnt.y = ((double)(fl%3+2))*sin(i);
    tmpPnt.z = 0.0;
    spl2->AddKnot(tmpPnt,fl);
    fl++;
  }
  spl2->Close();


  sgCSpline* spl2_obj = sgCreateSpline(*spl2);
  SG_SPLINE::Delete(spl2);
  sgGetScene()->AttachObject(spl2_obj);
  spl2_obj->SetAttribute(SG_OA_COLOR,12);
  spl2_obj->SetAttribute(SG_OA_LINE_THICKNESS, 2);

 
  SG_CIRCLE   cirGeo;
  SG_POINT    cirC = {0.0, 0.0, 0.0};
  SG_VECTOR    cirNor = {0.0, 0.0, 1.0};
  cirGeo.FromCenterRadiusNormal(cirC,1.6, cirNor);
  sgC2DObject*  cir = sgCreateCircle(cirGeo);
  sgGetScene()->AttachObject(cir);
  cir->SetAttribute(SG_OA_COLOR,12);
  cir->SetAttribute(SG_OA_LINE_THICKNESS, 2);

  SG_VECTOR extVec = {1,-2,5};

   sgC3DObject* exO = (sgC3DObject*)sgKinematic::Extrude((const sgC2DObject&)(*spl2_obj),
    (const sgC2DObject**)(&cir),1,extVec,true);

  sgGetScene()->AttachObject(exO);
  exO->SetAttribute(SG_OA_COLOR,30);

  SG_VECTOR transV1 = {-7,0,0};
  exO->InitTempMatrix()->Translate(transV1);
  exO->ApplyTempMatrix();
  exO->DestroyTempMatrix();
}

void OnBnClickedKinSpirSurf()
{
  sgGetScene()->Clear();

   SG_ARC   ArcGeo;
  SG_POINT    ArP1 = {-1.0, -3.0, 0.0};
  SG_POINT    ArP2 = {-1.0, -2.0, 0.0};
  SG_POINT    ArP3 = {0.0, -3.5, 0.0};
  ArcGeo.FromThreePoints(ArP1,ArP2,ArP3,false);
  sgC2DObject*  ar = sgCreateArc(ArcGeo);
  sgGetScene()->AttachObject(ar);
  ar->SetAttribute(SG_OA_COLOR,12);
  ar->SetAttribute(SG_OA_LINE_THICKNESS, 2);

  SG_POINT axeP1 = {2.0, -3.0, 0.0};
  SG_POINT axeP2 = {2.0, 3.0, 0.0};

  
  sgC3DObject* spirO = (sgC3DObject*)sgKinematic::Spiral((const sgC2DObject&)(*ar),NULL,0,
              axeP1,axeP2,4,10,15,false);

   sgGetScene()->AttachObject(spirO);
  spirO->SetAttribute(SG_OA_COLOR,85);

  SG_VECTOR transV1 = {0,-11.5,0};
  spirO->InitTempMatrix()->Translate(transV1);
  spirO->ApplyTempMatrix();
  spirO->DestroyTempMatrix();
}

void OnBnClickedKinSpirBod()
{
  sgGetScene()->Clear();

   SG_CIRCLE   cirGeo1;
  SG_POINT    cirC1 = {2.0, -2.0, 0.0};
  SG_VECTOR    cirNor1 = {0.0, 0.0, 1.0};
  cirGeo1.FromCenterRadiusNormal(cirC1,3.0, cirNor1);
  sgC2DObject*  cir1 = sgCreateCircle(cirGeo1);
  sgGetScene()->AttachObject(cir1);
  cir1->SetAttribute(SG_OA_COLOR,12);
  cir1->SetAttribute(SG_OA_LINE_THICKNESS, 2);

   SG_CIRCLE   cirGeo2;
  SG_POINT    cirC2 = {2.0, -2.3, 0.0};
  SG_VECTOR    cirNor2 = {0.0, 0.0, 1.0};
  cirGeo2.FromCenterRadiusNormal(cirC2,1.5, cirNor2);
  sgC2DObject*  cir2 = sgCreateCircle(cirGeo2);
  sgGetScene()->AttachObject(cir2);
  cir2->SetAttribute(SG_OA_COLOR,12);
  cir2->SetAttribute(SG_OA_LINE_THICKNESS, 2);

  SG_POINT axeP1 = {6.0, -3.0, 0.0};
  SG_POINT axeP2 = {6.0, 3.0, 0.0};

 
  sgC3DObject* spirO = (sgC3DObject*)sgKinematic::Spiral((const sgC2DObject&)(*cir1),
    (const sgC2DObject**)(&cir2),1,
    axeP1,axeP2,12,30,16,true);

  sgGetScene()->AttachObject(spirO);
  spirO->SetAttribute(SG_OA_COLOR,56);

  SG_VECTOR transV1 = {0,7,0};
  spirO->InitTempMatrix()->Translate(transV1);
  spirO->ApplyTempMatrix();
  spirO->DestroyTempMatrix();
}

void OnBnClickedKinPipeSurf()
{
  sgGetScene()->Clear();

   SG_ARC   ArcGeo;
  SG_POINT    ArP1 = {1.0, -4.0, 0.0};
  SG_POINT    ArP2 = {1.0, -3.6, 0.0};
  SG_POINT    ArP3 = {1.2, -3.5, 0.0};
  ArcGeo.FromThreePoints(ArP1,ArP2,ArP3,false);
  sgC2DObject*  ar = sgCreateArc(ArcGeo);
  sgGetScene()->AttachObject(ar);
  ar->SetAttribute(SG_OA_COLOR,12);
  ar->SetAttribute(SG_OA_LINE_THICKNESS, 2);

  sgCObject*   objcts[6];

  objcts[0] = sgCreateLine(0.0, -4.0, 0.0, 0.0, -2.0, 0.0);

  ArP1.x = 0.0; ArP1.y = -2.0; ArP1.z = 0.0;
  ArP2.x = 1.0; ArP2.y = -1.0; ArP2.z = 0.0;
  ArP3.x = 0.4; ArP3.y = -1.2; ArP3.z = 0.0;
  ArcGeo.FromThreePoints(ArP1,ArP2,ArP3,false);
  objcts[1] = sgCreateArc(ArcGeo);

  ArP1.x = 1.0; ArP1.y = -1.0; ArP1.z = 0.0;
  ArP2.x = 2.0; ArP2.y = 0.0; ArP2.z = 0.0;
  ArP3.x = 1.9; ArP3.y = -0.5; ArP3.z = 0.0;
  ArcGeo.FromThreePoints(ArP1,ArP2,ArP3,false);
  objcts[2] = sgCreateArc(ArcGeo);

  ArP1.x = 2.0; ArP1.y = 0.0; ArP1.z = 0.0;
  ArP2.x = 1.0; ArP2.y = 1.0; ArP2.z = 0.0;
  ArP3.x = 1.6; ArP3.y = 0.8; ArP3.z = 0.0;
  ArcGeo.FromThreePoints(ArP1,ArP2,ArP3,false);
  objcts[3] = sgCreateArc(ArcGeo);

  objcts[4] = sgCreateLine(1.0, 1.0, 0.0, -1.0, 1.0, 0.0);

  ArP1.x = -1.0; ArP1.y = 1.0; ArP1.z = 0.0;
  ArP2.x = -1.0; ArP2.y = 0.0; ArP2.z = 1.0;
  ArP3.x = -1.1; ArP3.y = 1.0; ArP3.z = 0.0;
  ArcGeo.FromThreePoints(ArP1,ArP2,ArP3,false);
  objcts[5] = sgCreateArc(ArcGeo);

  sgCContour* cnt1 = sgCContour::CreateContour(objcts,6);
  sgGetScene()->AttachObject(cnt1);
  cnt1->SetAttribute(SG_OA_COLOR,12);
  cnt1->SetAttribute(SG_OA_LINE_THICKNESS, 2);

  SG_POINT point_in_plane = {1.0, -4.0, 0.0};

  
  bool  close = false;
  sgC3DObject* pipO = (sgC3DObject*)sgKinematic::Pipe((const sgC2DObject&)(*ar),NULL,0,
    (const sgC2DObject&)(*cnt1), point_in_plane, 0.0, close);

    sgGetScene()->AttachObject(pipO);
  pipO->SetAttribute(SG_OA_COLOR,25);

  SG_VECTOR transV1 = {2.5,1,0};
  pipO->InitTempMatrix()->Translate(transV1);
  pipO->ApplyTempMatrix();
  pipO->DestroyTempMatrix();

}

void OnBnClickedKinPipeBod()
{
  sgGetScene()->Clear();

  sgCObject*   objcts[7];

  SG_POINT    ArP1;
  SG_POINT    ArP2;
  SG_POINT    ArP3;
  SG_ARC      ArcGeo;

  ArP1.x = 0.0; ArP1.y = -2.0; ArP1.z = 0.0;
  ArP2.x = 1.0; ArP2.y = -1.0; ArP2.z = 0.0;
  ArP3.x = 0.4; ArP3.y = -1.2; ArP3.z = 0.0;
  ArcGeo.FromThreePoints(ArP1,ArP2,ArP3,false);
  objcts[0] = sgCreateArc(ArcGeo);

  ArP1.x = 1.0; ArP1.y = -1.0; ArP1.z = 0.0;
  ArP2.x = 2.0; ArP2.y = 0.0; ArP2.z = 0.0;
  ArP3.x = 1.9; ArP3.y = -0.5; ArP3.z = 0.0;
  ArcGeo.FromThreePoints(ArP1,ArP2,ArP3,false);
  objcts[1] = sgCreateArc(ArcGeo);

  ArP1.x = 2.0; ArP1.y = 0.0; ArP1.z = 0.0;
  ArP2.x = 1.0; ArP2.y = 1.0; ArP2.z = 0.0;
  ArP3.x = 1.6; ArP3.y = 0.8; ArP3.z = 0.0;
  ArcGeo.FromThreePoints(ArP1,ArP2,ArP3,false);
  objcts[2] = sgCreateArc(ArcGeo);

  objcts[3] = sgCreateLine(1.0, 1.0, 0.0, -1.0, 1.0, 0.0);

  ArP1.x = -1.0; ArP1.y = 1.0; ArP1.z = 0.0;
  ArP2.x = -1.0; ArP2.y = 0.0; ArP2.z = 1.0;
  ArP3.x = -1.1; ArP3.y = 1.0; ArP3.z = 0.0;
  ArcGeo.FromThreePoints(ArP1,ArP2,ArP3,false);
  objcts[4] = sgCreateArc(ArcGeo);

  sgCContour* cnt1 = sgCContour::CreateContour(objcts,5);
  sgGetScene()->AttachObject(cnt1);
  cnt1->SetAttribute(SG_OA_COLOR,12);
  cnt1->SetAttribute(SG_OA_LINE_THICKNESS, 2);

    ArP1.x = -0.2; ArP1.y = -0.2; ArP1.z = 0.0;
  ArP2.x = -0.1; ArP2.y = 0.2; ArP2.z = 0.0;
  ArP3.x = -0.3; ArP3.y = 0.1; ArP3.z = 0.0;
  ArcGeo.FromThreePoints(ArP1,ArP2,ArP3,false);
  objcts[0] = sgCreateArc(ArcGeo);


  ArP1.x = -0.1; ArP1.y = 0.2; ArP1.z = 0.0;
  ArP2.x = 0.3; ArP2.y = 0.5; ArP2.z = 0.0;
  ArP3.x = 0.2; ArP3.y = 0.6; ArP3.z = 0.0;
  ArcGeo.FromThreePoints(ArP1,ArP2,ArP3,false);
  objcts[1] = sgCreateArc(ArcGeo);

  ArP1.x = 0.3; ArP1.y = 0.5; ArP1.z = 0.0;
  ArP2.x = -0.2; ArP2.y = -0.2; ArP2.z = 0.0;
  ArP3.x = 0.6; ArP3.y = -0.4; ArP3.z = 0.0;
  ArcGeo.FromThreePoints(ArP1,ArP2,ArP3,false);
  objcts[2] = sgCreateArc(ArcGeo);

  sgCContour* cnt2 = sgCContour::CreateContour(objcts,3);
  sgGetScene()->AttachObject(cnt2);
  cnt2->SetAttribute(SG_OA_COLOR,12);
  cnt2->SetAttribute(SG_OA_LINE_THICKNESS, 2);

    SG_CIRCLE   cirGeo;
  SG_POINT    cirC = {0.3, -0.1, 0.0};
  SG_VECTOR    cirNor = {0.0, 0.0, 1.0};
  cirGeo.FromCenterRadiusNormal(cirC,0.31, cirNor);
  sgC2DObject*  cir = sgCreateCircle(cirGeo);
  sgGetScene()->AttachObject(cir);
  cir->SetAttribute(SG_OA_COLOR,12);
  cir->SetAttribute(SG_OA_LINE_THICKNESS, 2);

  SG_POINT point_in_plane = {0.0,0.0,0.0};

  
  bool  close = true;
  sgC3DObject* pipO = (sgC3DObject*)sgKinematic::Pipe((const sgC2DObject&)(*cnt2),
    (const sgC2DObject**)(&cir),1,
    (const sgC2DObject&)(*cnt1), point_in_plane, 0.0, close);

    sgGetScene()->AttachObject(pipO);
  pipO->SetAttribute(SG_OA_COLOR,25);

  SG_VECTOR transV1 = {3.0,1.0,0};
  pipO->InitTempMatrix()->Translate(transV1);
  pipO->ApplyTempMatrix();
  pipO->DestroyTempMatrix();
}