// Demo.cpp
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Demo.h"
#include <stdio.h>

#include "OpenGL//Painter.h"
#include "Scenes//Scenes.h"


/////////////////////////////////////////////////////////////////////////////
// Global CDemoApp object

CDemoApp gApp;


/////////////////////////////////////////////////////////////////////////////
// CDemoApp construction/destruction

CDemoApp::CDemoApp()
{
}

CDemoApp::~CDemoApp()
{
}

//
// PreCreateWindow()
// Called before the main window is created. Override this function to change window creation params.
//
void CDemoApp::PreCreateWindow(WNDCLASSEX &wcex, DWORD &dwStyle, DWORD &dwExStyle, int &x, int &y, int &cx, int &cy)
{
  CApp::PreCreateWindow(wcex, dwStyle, dwExStyle, x, y, cx, cy);
  // TODO : Modify parameters to change default window style and/or size
}


//
// OnCommand()
// Override this function to handle WM_COMMAND messages sent to the main window.
//
BOOL CDemoApp::OnCommand(int nCmdID, int nEvent)
{
  switch (nCmdID)
  {
    case IDM_EXIT:
      SendMessage(m_hWnd, WM_CLOSE, 0, 0);
      break;

    case IDM_ABOUT:
      ShowAboutDialog();
      break;

	case ID_CAM_ROT:
		m_hand_action = HA_ROTATE;
		break;
	case ID_CAM_MOV:
		m_hand_action = HA_MOVE;
		break;
	case ID_CAM_ZOOM:
		m_hand_action = HA_ZOOM;
		break;
	case ID_CAM_FIT:
		FitToScene();
		OnPaint(m_hDC);
		break;

	case ID_SAVE:
		{
			OnBnClickedSave();
		}
		break;
	case ID_LOAD:
		{
			OnBnClickedLoad();
			FitToScene();
			OnPaint(m_hDC);
		}
		break;
	case ID_IMPORT_DXF:
		{
			OnBnClickedImportDXF();
			FitToScene();
			OnPaint(m_hDC);
		}
		break;
	case ID_EXPORT_DXF:
		{
			OnBnClickedExportDXF();
		}
		break;
	case ID_IMPORT_STL:
		{
			OnBnClickedImportSTL();
			FitToScene();
			OnPaint(m_hDC);
		}
		break;
	case ID_EXPORT_STL:
		{
			OnBnClickedExportSTL();
		}
		break;
	case ID_TRIANGLES_OBJ:
		{
			OnBnClickedFromTriangles();
			FitToScene();
			OnPaint(m_hDC);
		}
		break;

	case ID_PRIM_POINTS:
		OnBnClickedPrPoints();
		FitToScene();
		OnPaint(m_hDC);
		break;

	case ID_PRIM_LINES:
		OnBnClickedPrLines();
		FitToScene();
		OnPaint(m_hDC);
		break;

	case ID_PRIM_CIRCLES:
		OnBnClickedPrCircles();
		FitToScene();
		OnPaint(m_hDC);
		break;

	case ID_PRIM_ARCS:
		OnBnClickedPrArcs();
		FitToScene();
		OnPaint(m_hDC);
		break;

	case ID_PRIM_SPLINES:
		OnBnClickedPrSplines();
		FitToScene();
		OnPaint(m_hDC);
		break;

	case ID_PRIM_CONTOURS:
		OnBnClickedPrContours();
		FitToScene();
		OnPaint(m_hDC);
		break;

	case ID_PRIM_EQIUDI:
		OnBnClickedPrEquidi();
		FitToScene();
		OnPaint(m_hDC);
		break;

	case ID_PRIM_BOXES:
		OnBnClickedPrBoxes();
		FitToScene();
		OnPaint(m_hDC);
		break;

	case ID_PRIM_SPHERES:
		OnBnClickedPrSpheres();
		FitToScene();
		OnPaint(m_hDC);
		break;

	case ID_PRIM_CYL:
		OnBnClickedPrCyls();
		FitToScene();
		OnPaint(m_hDC);
		break;

	case ID_PRIM_CONES:
		OnBnClickedPrCones();
		FitToScene();
		OnPaint(m_hDC);
		break;

	case ID_PRIM_ELL:
		OnBnClickedPrEllipsoids();
		FitToScene();
		OnPaint(m_hDC);
		break;

	case ID_PRIM_TORS:
		OnBnClickedPrTors();
		FitToScene();
		OnPaint(m_hDC);
		break;

	case ID_PRIM_SPH_B:
		OnBnClickedPrSphericBands();
		FitToScene();
		OnPaint(m_hDC);
		break;

	case ID_BOOL_INTER	:
		OnBnClickedBInters();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_BOOL_UNION:
		OnBnClickedBUnion();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_BOOL_SUB:
		OnBnClickedBSub();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_BOOL_INT_SEC:
		OnBnClickedBIntCont();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_BOOL_PL_SECTIONS:
		OnBnClickedBSection();
		FitToScene();
		OnPaint(m_hDC);
		break;

	case ID_KIN_ROT_SUR:
		OnBnClickedKinRotSurf();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_KIN_ROT_BODY:
		OnBnClickedKinRotBod();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_KIN_EXTR_SUR:
		OnBnClickedKinExtrSurf();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_KIN_EXTR_BODY:
		OnBnClickedKinExtrBod();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_KIN_SPIR_SUR:
		OnBnClickedKinSpirSurf();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_KIN_SPIR_BODY:
		OnBnClickedKinSpirBod();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_KIN_PIPE_SUR:
		OnBnClickedKinPipeSurf();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_KIN_PIPE_BODY:
		OnBnClickedKinPipeBod();
		FitToScene();
		OnPaint(m_hDC);
		break;

	case ID_SUR_MESH:
		OnBnClickedSurfMesh();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_SUR_FACE:
		OnBnClickedSurfFace();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_SUR_COONS_3:
		OnBnClickedSurfCoons3();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_SUR_COONS_4:
		OnBnClickedSurfCoons4();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_SUR_LINEAR:
		OnBnClickedSurfLinear();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_SUR_CLIPS:
		OnBnClickedSurfFromSect();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_SUR_CL_BOD:
		OnBnClickedSurfBodyFromSect();
		FitToScene();
		OnPaint(m_hDC);
		break;



	case ID_CS_ROOM:
		OnBnClickedScenesRoom();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_CS_DRILLS:
		OnBnClickedScenesDrills();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_CS_CLOCK:
		OnBnClickedScenesClock();
		FitToScene();
		OnPaint(m_hDC);
		break;

	case ID_TEXT1:
		OnBnClickedText1();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_TEXT2:
		OnBnClickedText2();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_DIM1:
		OnBnClickedDim1();
		FitToScene();
		OnPaint(m_hDC);
		break;
	case ID_DIM2:
		OnBnClickedDim2();
		FitToScene();
		OnPaint(m_hDC);
		break;



    default:
      return CApp::OnCommand(nCmdID, nEvent); // Call default handler
  }
  return TRUE;
}

//
// WindowProc()
// Override this function to handle messages sent to the main window.
//
LRESULT CDemoApp::WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  return CApp::WindowProc(hWnd, message, wParam, lParam); // Call default WindowProc
}

//
// InitScene()
// Called when the OpenGL RC has been created. Sets initial state for the OpenGL scene.
//
void CDemoApp::InitScene()
{
OnBnClickedPrSpheres();
 

  // Lights properties
  //float ambientProperties[]  = {0.1f, 0.1f, 0.1f, 1.0f};
  float diffuseProperties[]  = {1.0f, 1.0f, 1.0f, 1.0f};
  float specularProperties[] = {1.0f, 1.0f, 1.0f, 1.0f};

  //glLightfv( GL_LIGHT0, GL_AMBIENT, ambientProperties);
  glLightfv( GL_LIGHT0, GL_DIFFUSE,diffuseProperties);
  glLightfv( GL_LIGHT0, GL_SPECULAR, specularProperties);
  glLightModelf(GL_LIGHT_MODEL_TWO_SIDE, 1.0);

  glClearColor(1.0,1.0,1.0,1.0f);

  glHint(GL_LINE_SMOOTH_HINT,GL_FASTEST);

  // Texture
  glEnable(GL_TEXTURE_2D);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);


  // Default : lighting

  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);


  // Default : blending
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

  glEnable(GL_DEPTH_TEST);

  //  glEnable(GL_CULL_FACE);
}

//
// KillScene()
// Called when the OpenGL RC is about to be destroyed.
//
void CDemoApp::KillScene()
{
  // TODO: Use KillScene to free resources.
}

//
// DrawScene()
// Called each time the OpenGL scene has to be drawn.
//
void CDemoApp::DrawScene()
{
// TODO: Replace the following sample code with your code to draw the scene.

  sgCObject*  curObj = sgGetScene()->GetObjectsList()->GetHead();
  while (curObj)
  {
    if (true)
    {
      Painter::DrawObject(GL_RENDER,curObj,false);

      if ((curObj->GetAttribute(SG_OA_DRAW_STATE) & SG_DS_GABARITE))
      {
        SG_POINT a1,a2;
        curObj->GetGabarits(a1,a2);
        Painter::DrawGabariteBox(a1,a2);
      }
    }
    curObj = sgGetScene()->GetObjectsList()->GetNext(curObj);
  }
}

void  AddFloorInScene(double size1, double size2, 
					  double x_shift, double y_shift, double z_shift)
{
	sgCObject*   objects_buffer[4];
	objects_buffer[0] = sgCreateLine(size1/2.0, size2/2.0, 0.0, 
		-size1/2.0, size2/2.0, 0.0);
	objects_buffer[1] = sgCreateLine(-size1/2.0, size2/2.0, 0.0, 
		-size1/2.0, -size2/2.0, 0.0);
	objects_buffer[2] = sgCreateLine(-size1/2.0, -size2/2.0, 0.0, 
		size1/2.0, -size2/2.0, 0.0);
	objects_buffer[3] = sgCreateLine(size1/2.0, -size2/2.0, 0.0, 
		size1/2.0, size2/2.0, 0.0);

	sgCContour*  cnt = sgCContour::CreateContour(objects_buffer,4);

	sgCObject*   floor = sgSurfaces::Face((const sgC2DObject&)(*cnt),NULL,0);
	sgDeleteObject(cnt);

	sgGetScene()->AttachObject(floor);
	floor->SetAttribute(SG_OA_COLOR,25);

	SG_VECTOR transV = {x_shift, y_shift, z_shift};
	floor->InitTempMatrix()->Translate(transV);
	floor->ApplyTempMatrix();
	floor->DestroyTempMatrix();

}