#include "..//..//stdafx.h"
#include "ClockScene.h"


CClockScene::CClockScene()
{
	sgGetScene()->Clear();
	
	SG_CIRCLE cirG;
	cirG.center.x = cirG.center.y =  cirG.center.z = 0.0;
	cirG.normal.x = cirG.normal.y =  0.0; cirG.normal.z = 1.0;
	cirG.radius = 10.0;

	sgCCircle* cir = sgCreateCircle(cirG);
	m_face = sgSurfaces::Face(*cir,NULL,0);
	sgDeleteObject(cir);
	sgGetScene()->AttachObject(m_face);
	m_face->SetAttribute(SG_OA_COLOR,35);
	m_face->SetAttribute(SG_OA_LINE_THICKNESS, 1);
	SG_VECTOR trVec = {0.0, 0.0, -0.03};
	m_face->InitTempMatrix()->Translate(trVec);
	m_face->ApplyTempMatrix();
	m_face->DestroyTempMatrix();
	//SetMaterialToObject(m_face,MATERIAL_GRANITE_10);

	
	m_face_tor = sgCTorus::Create(10.0, 0.2,36,24);
	sgGetScene()->AttachObject(m_face_tor);
	m_face_tor->SetAttribute(SG_OA_COLOR,30);
	m_face_tor->SetAttribute(SG_OA_LINE_THICKNESS, 1);
	//SetMaterialToObject(m_face_tor,MATERIAL_METALL_GOLD_2);


	sgCContour* tmpCnt = CreateHairLine();
	SG_VECTOR extrVec = {0.0, 0.0, 0.2};
	m_hairLines3D[0] = sgKinematic::Extrude((const sgC2DObject&)(*tmpCnt),NULL,0,extrVec,true);
	sgDeleteObject(tmpCnt);
	sgGetScene()->AttachObject(m_hairLines3D[0]);
	m_hairLines3D[0]->SetAttribute(SG_OA_COLOR,12);
	m_hairLines3D[0]->SetAttribute(SG_OA_LINE_THICKNESS, 1);
	//SetMaterialToObject(m_hairLines3D[0],MATERIAL_METALL_SILVER_5);


	SG_POINT     rotAxeP = {0.0, 0.0, 0.0};
	SG_VECTOR    rotAxeDir = {0.0, 0.0, 1.0};
	for (int i=1;i<12;i++)
	{
		m_hairLines3D[i] = (sgCContour*)(m_hairLines3D[0]->Clone());
		m_hairLines3D[i]->InitTempMatrix()->Rotate(rotAxeP,rotAxeDir,i*3.14159265/6.0);
		m_hairLines3D[i]->ApplyTempMatrix();
		m_hairLines3D[i]->DestroyTempMatrix();
		sgGetScene()->AttachObject(m_hairLines3D[i]);
		m_hairLines3D[i]->SetAttribute(SG_OA_COLOR,90);
		//SetMaterialToObject(m_hairLines3D[i],MATERIAL_METALL_SILVER_5);

	}

	m_hairLines2D[0] = sgCreateLine(0.0, 8.0, 0.0, 0.0, 9.0, 0.0);
	sgGetScene()->AttachObject(m_hairLines2D[0]);

	
	for (int i=1;i<60;i++)
	{
		m_hairLines2D[i] = (sgCContour*)(m_hairLines2D[0]->Clone());
		m_hairLines2D[i]->InitTempMatrix()->Rotate(rotAxeP,rotAxeDir,i*3.14159265/30.0);
		m_hairLines2D[i]->ApplyTempMatrix();
		m_hairLines2D[i]->DestroyTempMatrix();
		sgGetScene()->AttachObject(m_hairLines2D[i]);
		m_hairLines2D[i]->SetAttribute(SG_OA_COLOR,0);
	}
	m_clock_center = sgCreateSphere(0.2,36,36);
	sgGetScene()->AttachObject(m_clock_center);
	m_clock_center->SetAttribute(SG_OA_COLOR,3);

	m_hour_hand = CreateHourHand();

	sgGetScene()->AttachObject(m_hour_hand);
	m_hour_hand->SetAttribute(SG_OA_COLOR,3);
	
	m_hour_hand->InitTempMatrix()->Rotate(rotAxeP,rotAxeDir,3.0*3.14159265/2.0-0.6);
	m_hour_hand->ApplyTempMatrix();
	m_hour_hand->DestroyTempMatrix();


	m_min_hand = CreateMinuteHand();

	sgGetScene()->AttachObject(m_min_hand);
	m_min_hand->SetAttribute(SG_OA_COLOR,3);
	
	m_sec_hand = CreateSecondHand();

	sgGetScene()->AttachObject(m_sec_hand);
	m_sec_hand->SetAttribute(SG_OA_COLOR,3);
	m_sec_hand->SetAttribute(SG_OA_LINE_THICKNESS,1);

	m_sec_hand->InitTempMatrix()->Rotate(rotAxeP,rotAxeDir,2.14159265);
	m_sec_hand->ApplyTempMatrix();
	m_sec_hand->DestroyTempMatrix();

}

CClockScene::~CClockScene()
{
}

sgCContour*  CClockScene::CreateHairLine()
{
	sgCObject*  objcts[4];

	SG_ARC arcGeo;
	SG_POINT arcP1;
	SG_POINT arcP2;
	SG_POINT arcP3;

	arcP1.x = -0.15;  arcP1.y = 9.0;   arcP1.z = 0.0;
	arcP2.x = 0.15;   arcP2.y = 9.0;   arcP2.z = 0.0;
	arcP3.x = 0.0;    arcP3.y = 9.2;   arcP3.z = 0.0;

	arcGeo.FromThreePoints(arcP1,arcP2,arcP3,false);

	objcts[0] = sgCreateArc(arcGeo);

	objcts[1] = sgCreateLine(0.15, 9.0, 0.0, 0.15, 8.0, 0.0);

	arcP1.x = 0.15;  arcP1.y = 8.0;   arcP1.z = 0.0;
	arcP2.x = -0.15;   arcP2.y = 8.0;   arcP2.z = 0.0;
	arcP3.x = 0.0;    arcP3.y = 7.8;   arcP3.z = 0.0;

	arcGeo.FromThreePoints(arcP1,arcP2,arcP3,false);

	objcts[2] = sgCreateArc(arcGeo);

	objcts[3] = sgCreateLine(-0.15, 8.0, 0.0, -0.15, 9.0, 0.0);

	return sgCContour::CreateContour(objcts,4);
}

sgCObject* CClockScene::CreateHourHand()
{
	sgCObject*  ob_buff[4];

	ob_buff[0] = sgCreateLine(0.0, -0.1, 0.0, 0.5, 0.5, 0.0);
	ob_buff[1] = sgCreateLine(0.5, 0.5, 0.0, 0.0, 6.0, 0.0);
	ob_buff[2] = sgCreateLine(0.0, 6.0, 0.0, -0.5, 0.5, 0.0);
	ob_buff[3] = sgCreateLine(-0.5, 0.5, 0.0, 0.0, -0.1, 0.0);

	sgC2DObject* cont1 = sgCContour::CreateContour(ob_buff,4);

	ob_buff[0] = sgCreateLine(0.0, 0.6, 0.0, 0.2, 0.8, 0.0);
	ob_buff[1] = sgCreateLine(0.2, 0.8, 0.0, 0.0, 5.0, 0.0);
	ob_buff[2] = sgCreateLine(0.0, 5.0, 0.0, -0.2, 0.8, 0.0);
	ob_buff[3] = sgCreateLine(-0.2, 0.8, 0.0, 0.0, 0.6, 0.0);
	sgC2DObject* cont2 = sgCContour::CreateContour(ob_buff,4);


	sgCObject* res = sgSurfaces::Face(*cont1,(const sgC2DObject**)(&cont2),1);
	sgDeleteObject(cont1);
	sgDeleteObject(cont2);
	return res;
}

sgCObject* CClockScene::CreateMinuteHand()
{
	sgCObject*  ob_buff[4];

	ob_buff[0] = sgCreateLine(0.0, -0.1, 0.0, 0.5, 0.5, 0.0);
	ob_buff[1] = sgCreateLine(0.5, 0.5, 0.0, 0.0, 9.0, 0.0);
	ob_buff[2] = sgCreateLine(0.0, 9.0, 0.0, -0.5, 0.5, 0.0);
	ob_buff[3] = sgCreateLine(-0.5, 0.5, 0.0, 0.0, -0.1, 0.0);

	sgC2DObject* cont1 = sgCContour::CreateContour(ob_buff,4);

	ob_buff[0] = sgCreateLine(0.0, 1.6, 0.0, 0.2, 1.8, 0.0);
	ob_buff[1] = sgCreateLine(0.2, 1.8, 0.0, 0.0, 8.0, 0.0);
	ob_buff[2] = sgCreateLine(0.0, 8.0, 0.0, -0.2, 1.8, 0.0);
	ob_buff[3] = sgCreateLine(-0.2, 1.8, 0.0, 0.0, 1.6, 0.0);
	sgC2DObject* cont2 = sgCContour::CreateContour(ob_buff,4);


	sgCObject* res = sgSurfaces::Face(*cont1,(const sgC2DObject**)(&cont2),1);
	sgDeleteObject(cont1);
	sgDeleteObject(cont2);
	return res;
}

sgCObject* CClockScene::CreateSecondHand()
{
	return sgCreateLine(0.0, 0.0, 0.0, 0.0, 9.0, 0.0);
}
