#include "DrillsScene.h"

#include <cstdlib>

CDrillsScene::CDrillsScene()
{
	sgGetScene()->Clear();
	m_drills[0] = CreateDrill(1.0,5.0);
	

	m_drills[1] = m_drills[0]->Clone();
	

	m_drills[2] = m_drills[0]->Clone();
	

	m_drills[3] = m_drills[0]->Clone();
	

	sgCCylinder*  holes[5];
	for (int i=0;i<4;i++)
		holes[i] = sgCCylinder::Create(1.0, 20.0, 24);
	holes[4] = sgCCylinder::Create(2.5, 20.0, 24);

	SG_VECTOR    transVec = {15.0, 15.0, 0.0};
	m_drills[0]->InitTempMatrix()->Translate(transVec);
	m_drills[0]->ApplyTempMatrix();
	m_drills[0]->DestroyTempMatrix();
	transVec.z = -10.0;
	holes[0]->InitTempMatrix()->Translate(transVec);
	holes[0]->ApplyTempMatrix();
	holes[0]->DestroyTempMatrix();

	sgGetScene()->AttachObject(m_drills[0]);
	m_drills[0]->SetAttribute(SG_OA_COLOR,2);
	m_drills[0]->SetAttribute(SG_OA_LINE_THICKNESS, 1);

	
	transVec.x = -15.0;
	transVec.y = 15.0;
	transVec.z = 0.0;
	m_drills[1]->InitTempMatrix()->Translate(transVec);
	m_drills[1]->ApplyTempMatrix();
	m_drills[1]->DestroyTempMatrix();
	transVec.z = -10.0;
	holes[1]->InitTempMatrix()->Translate(transVec);
	holes[1]->ApplyTempMatrix();
	holes[1]->DestroyTempMatrix();

	sgGetScene()->AttachObject(m_drills[1]);
	m_drills[1]->SetAttribute(SG_OA_COLOR,3);
	m_drills[1]->SetAttribute(SG_OA_LINE_THICKNESS, 1);


	transVec.x = -15.0;
	transVec.y = -15.0;
	transVec.z = 0.0;
	m_drills[2]->InitTempMatrix()->Translate(transVec);
	m_drills[2]->ApplyTempMatrix();
	m_drills[2]->DestroyTempMatrix();
	transVec.z = -10.0;
	holes[2]->InitTempMatrix()->Translate(transVec);
	holes[2]->ApplyTempMatrix();
	holes[2]->DestroyTempMatrix();
	sgGetScene()->AttachObject(m_drills[2]);
	m_drills[2]->SetAttribute(SG_OA_COLOR,4);
	m_drills[2]->SetAttribute(SG_OA_LINE_THICKNESS, 1);

	transVec.x = 15.0;
	transVec.y = -15.0;
	transVec.z = 0.0;
	m_drills[3]->InitTempMatrix()->Translate(transVec);
	m_drills[3]->ApplyTempMatrix();
	m_drills[3]->DestroyTempMatrix();
	transVec.z = -10.0;
	holes[3]->InitTempMatrix()->Translate(transVec);
	holes[3]->ApplyTempMatrix();
	holes[3]->DestroyTempMatrix();
	sgGetScene()->AttachObject(m_drills[3]);
	m_drills[3]->SetAttribute(SG_OA_COLOR,5);
	m_drills[3]->SetAttribute(SG_OA_LINE_THICKNESS, 1);

	m_drills[4] = CreateDrill(2.5,8.0);
	sgGetScene()->AttachObject(m_drills[4]);
	m_drills[4]->SetAttribute(SG_OA_COLOR,10);
	m_drills[4]->SetAttribute(SG_OA_LINE_THICKNESS, 1);
	
	transVec.x = 0.0;
	transVec.y = 0.0;
	transVec.z = -10.0;
	holes[4]->InitTempMatrix()->Translate(transVec);
	holes[4]->ApplyTempMatrix();
	holes[4]->DestroyTempMatrix();

	sgCObject*  tmpOb1;
	sgCGroup*   tmpGroup;
	tmpOb1 = sgCreateBox(40.0,40.0, 1.0);
	transVec.x = -20.0;
	transVec.y = -20.0;
	transVec.z = -4.0;
	tmpOb1->InitTempMatrix()->Translate(transVec);
	tmpOb1->ApplyTempMatrix();
	tmpOb1->DestroyTempMatrix();
	
	for (int i=0;i<5;i++)
	{
		tmpGroup = sgBoolean::Sub((const sgC3DObject&)(*tmpOb1),
									(const sgC3DObject&)(*holes[i]));
		sgDeleteObject(tmpOb1);
		tmpGroup->BreakGroup(&tmpOb1);
		sgDeleteObject(tmpGroup);
		sgDeleteObject(holes[i]);
	}
	
	m_box = tmpOb1;
		
	sgGetScene()->AttachObject(m_box);
	m_box->SetAttribute(SG_OA_COLOR,10);
	m_box->SetAttribute(SG_OA_LINE_THICKNESS, 1);
}

CDrillsScene::~CDrillsScene()
{
}

sgCContour* CDrillsScene::CreateDrillSection(double rad)
{
	sgCObject*  objcts[6];

	objcts[0] = sgCreateLine(0.0, -0.99*rad, 0.0, -0.05*rad, -0.99*rad, 0.0);
	objcts[1] = sgCreateLine(-0.05*rad, -0.99*rad, 0.0, -0.05*rad, -0.97*rad, 0.0);

	SG_ARC arcGeo;
	SG_POINT arcP1;
	SG_POINT arcP2;
	SG_POINT arcP3;

	arcP1.x = -0.05*rad;  arcP1.y = -0.97*rad; arcP1.z = 0.0;
	arcP2.x = -1.0*rad;   arcP2.y = 0.0;       arcP2.z = 0.0;
	arcP3.x = -0.87*rad;  arcP3.y = -0.5*rad;  arcP3.z = 0.0;

	arcGeo.FromThreePoints(arcP1,arcP2,arcP3,false);

	objcts[2] = sgCreateArc(arcGeo);

	arcP1.x = -1.0*rad;   arcP1.y = 0.0;       arcP1.z = 0.0;
	arcP2.x = -0.05*rad;  arcP2.y = 0.0;       arcP2.z = 0.0;
	arcP3.x = -0.35*rad;  arcP3.y = -0.33*rad; arcP3.z = 0.0;

	arcGeo.FromThreePoints(arcP1,arcP2,arcP3,false);

	objcts[3] = sgCreateArc(arcGeo);

	objcts[4] = sgCreateLine(-0.05*rad, 0.0, 0.0, -0.05*rad, 0.99*rad, 0.0);
	objcts[5] = sgCreateLine(-0.05*rad, 0.99*rad, 0.0, 0.0, 0.99*rad, 0.0);

	sgCContour*  cnt1 = sgCContour::CreateContour(objcts,6);
	sgCContour*  cnt2 = (sgCContour*)cnt1->Clone();

	SG_POINT     rotAxeP = {0.0, 0.0, 0.0};
	SG_VECTOR    rotAxeDir = {0.0, 0.0, 1.0};
	cnt2->InitTempMatrix()->Rotate(rotAxeP,rotAxeDir,3.14159265);
	cnt2->ApplyTempMatrix();
	cnt2->DestroyTempMatrix();
	
	objcts[0] = cnt1;
	objcts[1] = cnt2;

	return sgCContour::CreateContour(objcts,2);
}

sgCObject* CDrillsScene::CreateDrill(double rad, double dH)
{
	sgC2DObject* drill_1_sections[10];
	float       params[10];
	
	for (int i=0;i<10;i++)
		params[i] = 0;
	
	drill_1_sections[0] = CreateDrillSection(rad);

	SG_POINT     rotAxeP = {0.0, 0.0, 0.0};
	SG_VECTOR    rotAxeDir = {0.0, 0.0, 1.0};
	SG_VECTOR    transVec = {0.0, 0.0, 1.0};
	for (int i=1;i<7;i++)
	{
		drill_1_sections[i] = (sgCContour*)(drill_1_sections[0]->Clone());
		drill_1_sections[i]->InitTempMatrix()->Rotate(rotAxeP,rotAxeDir,i*5.0*3.14159265/6.0);
		transVec.z = dH*i;
		drill_1_sections[i]->GetTempMatrix()->Translate(transVec);
		drill_1_sections[i]->ApplyTempMatrix();
		drill_1_sections[i]->DestroyTempMatrix();
	}

	SG_CIRCLE cirGeo;
	cirGeo.center.x = cirGeo.center.y = 0.0;  cirGeo.center.z =  7*dH+5;
	cirGeo.normal.x = cirGeo.normal.y = 0.0;  cirGeo.normal.z = 1.0;
	cirGeo.radius = rad-0.1;

	drill_1_sections[7] = sgCreateCircle(cirGeo);
	drill_1_sections[7]->ChangeOrient();
	cirGeo.center.z = 7*dH+10;
	drill_1_sections[8] = sgCreateCircle(cirGeo);
	drill_1_sections[8]->ChangeOrient();
	cirGeo.center.z =7*dH+15;
	drill_1_sections[9] = sgCreateCircle(cirGeo);
	drill_1_sections[9]->ChangeOrient();


	sgCObject* resul = sgSurfaces::SplineSurfaceFromSections((const sgC2DObject**)drill_1_sections,
		params,10,true);

	for (int i=0;i<10;i++)
		sgDeleteObject(drill_1_sections[i]);

	return resul;
}

